Index: uspace/lib/draw/cursor.c
===================================================================
--- uspace/lib/draw/cursor.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/cursor.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,91 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <malloc.h>
+
+#include "cursor.h"
+#include "cursor/embedded.h"
+
+void cursor_init(cursor_t *cursor, cursor_decoder_type_t decoder, char *path)
+{
+	switch (decoder) {
+	case CURSOR_DECODER_EMBEDDED:
+		cursor->decoder = &cd_embedded;
+		break;
+	default:
+		cursor->decoder = NULL;
+		break;
+	}
+
+	if (cursor->decoder) {
+		cursor->decoder->init(path, &cursor->state_count, &cursor->decoder_data);
+
+		if (cursor->state_count > 0) {
+			cursor->states = (surface_t **) malloc(sizeof(surface_t *) * cursor->state_count);
+		} else {
+			cursor->states = NULL;
+		}
+
+		if (cursor->states) {
+			for (size_t i = 0; i < cursor->state_count; ++i) {
+				cursor->states[i] = cursor->decoder->render(i);
+			}
+		} else {
+			cursor->state_count = 0;
+		}
+	} else {
+		cursor->state_count = 0;
+		cursor->states = NULL;
+	}
+}
+
+void cursor_release(cursor_t *cursor)
+{
+	if (cursor->states) {
+		for (size_t i = 0; i < cursor->state_count; ++i) {
+			if (cursor->states[i]) {
+				surface_destroy(cursor->states[i]);
+			}
+		}
+		free(cursor->states);
+	}
+
+	if (cursor->decoder) {
+		cursor->decoder->release(cursor->decoder_data);
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/draw/cursor.h
===================================================================
--- uspace/lib/draw/cursor.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/cursor.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_CURSOR_H_
+#define DRAW_CURSOR_H_
+
+#include <sys/types.h>
+
+#include "surface.h"
+
+typedef enum {
+	CURSOR_DECODER_EMBEDDED
+} cursor_decoder_type_t;
+
+typedef struct {
+	void (*init)(char *, uint8_t *, void **);
+	surface_t *(*render)(uint8_t);
+	void (*release)(void *);
+} cursor_decoder_t;
+
+typedef struct cursor {
+	uint8_t state_count;
+	surface_t **states;
+	cursor_decoder_t *decoder;
+	void *decoder_data;
+} cursor_t;
+
+extern void cursor_init(cursor_t *, cursor_decoder_type_t, char *);
+extern void cursor_release(cursor_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/cursor/embedded.c
===================================================================
--- uspace/lib/draw/cursor/embedded.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/cursor/embedded.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,90 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <sys/types.h>
+#include <malloc.h>
+
+#include "../gfx/cursor-11x18.h"
+#include "embedded.h"
+#include "../surface.h"
+
+static void cde_init(char *path, uint8_t *state_count, void **data)
+{
+	assert(state_count);
+	assert(data);
+
+	(*state_count) = 1;
+	(*data) = NULL;
+}
+
+static surface_t *cde_render(uint8_t state)
+{
+	if (state != 0) {
+		return NULL;
+	}
+
+	surface_t *surface = surface_create(CURSOR_WIDTH, CURSOR_HEIGHT, NULL, 0);
+
+	if (!surface) {
+		return NULL;
+	}
+	
+	for (unsigned int y = 0; y < CURSOR_HEIGHT; ++y) {
+		for (unsigned int x = 0; x < CURSOR_WIDTH; ++x) {
+			size_t offset = y * ((CURSOR_WIDTH - 1) / 8 + 1) + x / 8;
+			bool visible = cursor_mask[offset] & (1 << (x % 8));
+			pixel_t pixel = (cursor_texture[offset] & (1 << (x % 8))) ?
+			    PIXEL(255, 0, 0, 0) : PIXEL(255, 255, 255, 255);
+			surface_put_pixel(surface, x, y, visible ? pixel : PIXEL(0, 0, 0, 0));
+		}
+	}
+
+	return surface;
+}
+
+static void cde_release(void *data)
+{
+	/* no-op */
+}
+
+cursor_decoder_t cd_embedded = {
+	.init = cde_init,
+	.render = cde_render,
+	.release = cde_release
+};
+
+/** @}
+ */
Index: uspace/lib/draw/cursor/embedded.h
===================================================================
--- uspace/lib/draw/cursor/embedded.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/cursor/embedded.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_CURSOR_EMBEDDED_H_
+#define DRAW_CURSOR_EMBEDDED_H_
+
+#include "../cursor.h"
+
+extern cursor_decoder_t cd_embedded;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/drawctx.c
===================================================================
--- uspace/lib/draw/drawctx.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/drawctx.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,200 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <adt/list.h>
+#include <malloc.h>
+
+#include "drawctx.h"
+
+void drawctx_init(drawctx_t *context, surface_t *surface)
+{
+	assert(surface);
+	list_initialize(&context->list);
+	context->surface = surface;
+	context->compose = compose_src;
+	context->mask = NULL;
+	context->source = NULL;
+	context->shall_clip = false;
+	context->clip_x = 0;
+	context->clip_y = 0;
+	surface_get_resolution(surface, &context->clip_width, &context->clip_height);
+}
+
+void drawctx_save(drawctx_t *context)
+{
+	drawctx_t *to_save = (drawctx_t *) malloc(sizeof(drawctx_t));
+	if (to_save) {
+		link_initialize(&to_save->link);
+		to_save->compose = context->compose;
+		to_save->mask = context->mask;
+		to_save->source = context->source;
+		to_save->shall_clip = context->shall_clip;
+		to_save->clip_x = context->clip_x;
+		to_save->clip_y = context->clip_y;
+		to_save->clip_width = context->clip_width;
+		to_save->clip_height = context->clip_height;
+		list_append(&to_save->link, &context->list);
+	}
+}
+
+void drawctx_restore(drawctx_t *context)
+{
+	drawctx_t *to_load = (drawctx_t *) list_last(&context->list);
+	if (to_load) {
+		list_remove(&to_load->link);
+		context->compose = to_load->compose;
+		context->mask = to_load->mask;
+		context->source = to_load->source;
+		context->shall_clip = to_load->shall_clip;
+		context->clip_x = to_load->clip_x;
+		context->clip_y = to_load->clip_y;
+		context->clip_width = to_load->clip_width;
+		context->clip_height = to_load->clip_height;
+		free(to_load);
+	}
+}
+
+void drawctx_set_compose(drawctx_t *context, compose_t compose)
+{
+	context->compose = compose;
+}
+
+void drawctx_set_clip(drawctx_t *context,
+    sysarg_t x, sysarg_t y, sysarg_t width, sysarg_t height)
+{
+	surface_get_resolution(context->surface,
+	    &context->clip_width, &context->clip_height);
+	context->shall_clip = (x > 0) || (y > 0) ||
+	    (width < context->clip_width) || (height < context->clip_height);
+
+	context->clip_x = x;
+	context->clip_y = y;
+	context->clip_width = width;
+	context->clip_height = height;
+}
+
+void drawctx_set_mask(drawctx_t *context, surface_t *mask)
+{
+	context->mask = mask;
+}
+
+void drawctx_set_source(drawctx_t *context, source_t *source)
+{
+	context->source = source;
+}
+
+void drawctx_set_font(drawctx_t *context, font_t *font)
+{
+	context->font = font;
+}
+
+void drawctx_transfer(drawctx_t *context,
+    sysarg_t x, sysarg_t y, sysarg_t width, sysarg_t height)
+{
+	if (!context->source) {
+		return;
+	}
+
+	bool clipped = false;
+	bool masked = false;
+
+	for (sysarg_t _y = y; _y < y + height; ++_y) {
+		for (sysarg_t _x = x; _x < x + width; ++_x) {
+			if (context->shall_clip) {
+				clipped = _x < context->clip_x && _x >= context->clip_width
+				    && _y < context->clip_y && _y >= context->clip_height;
+			}
+			
+			if (context->mask) {
+				pixel_t p = surface_get_pixel(context->mask, _x, _y);
+				masked = p > 0 ? false : true;
+			}
+
+			if (!clipped && !masked) {
+				pixel_t p_src = source_determine_pixel(context->source, _x, _y);
+				pixel_t p_dst = surface_get_pixel(context->surface, _x, _y);
+				pixel_t p_res = context->compose(p_src, p_dst);
+				surface_put_pixel(context->surface, _x, _y, p_res);
+			}
+		}
+	}
+}
+
+void drawctx_stroke(drawctx_t *context, path_t *path)
+{
+	if (!context->source || !path) {
+		return;
+	}
+
+	/* Note:
+	 * Antialiasing could be achieved by up-scaling path coordinates and
+	 * rendering into temporary higher-resolution surface. Then, the temporary
+	 * surface would be set as a source and its damaged region would be
+	 * transferred to the original surface. */
+
+	list_foreach(*((list_t *) path), link) {
+		path_step_t *step = (path_step_t *) link;
+		switch (step->type) {
+		case PATH_STEP_MOVETO:
+			// TODO
+			break;
+		case PATH_STEP_LINETO:
+			// TODO
+			break;
+		default:
+			break;
+		}
+	}
+}
+
+void drawctx_fill(drawctx_t *context, path_t *path)
+{
+	if (!context->source || !path) {
+		return;
+	}
+
+	// TODO
+}
+
+void drawctx_print(drawctx_t *context, const char *text, sysarg_t x, sysarg_t y)
+{
+	if (context->font && context->source) {
+		font_draw_text(context->font, context, context->source, text, x, y);
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/draw/drawctx.h
===================================================================
--- uspace/lib/draw/drawctx.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/drawctx.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_DRAWCTX_H_
+#define DRAW_DRAWCTX_H_
+
+#include <sys/types.h>
+#include <bool.h>
+
+#include <compose.h>
+
+#include "surface.h"
+#include "source.h"
+#include "path.h"
+#include "font.h"
+
+typedef struct drawctx {
+	link_t link;
+	list_t list;
+
+	surface_t *surface;
+	compose_t compose;
+	surface_t *mask;
+	source_t *source;
+	font_t *font;
+
+	bool shall_clip;
+	sysarg_t clip_x;
+	sysarg_t clip_y;
+	sysarg_t clip_width;
+	sysarg_t clip_height;
+} drawctx_t;
+
+extern void drawctx_init(drawctx_t *, surface_t *);
+
+extern void drawctx_save(drawctx_t *);
+extern void drawctx_restore(drawctx_t *);
+
+extern void drawctx_set_compose(drawctx_t *, compose_t);
+extern void drawctx_set_clip(drawctx_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t);
+extern void drawctx_set_mask(drawctx_t *, surface_t *);
+extern void drawctx_set_source(drawctx_t *, source_t *);
+extern void drawctx_set_font(drawctx_t *, font_t *);
+
+extern void drawctx_transfer(drawctx_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t);
+extern void drawctx_stroke(drawctx_t *, path_t *);
+extern void drawctx_fill(drawctx_t *, path_t *);
+extern void drawctx_print(drawctx_t *, const char *, sysarg_t, sysarg_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/font.c
===================================================================
--- uspace/lib/draw/font.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/font.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,169 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <malloc.h>
+
+#include "font.h"
+#include "font/embedded.h"
+#include "drawctx.h"
+
+void font_init(font_t *font, font_decoder_type_t decoder, char *path, uint16_t points)
+{
+	font->points = points;
+
+	switch (decoder) {
+	case FONT_DECODER_EMBEDDED:
+		font->decoder = &fd_embedded;
+		break;
+	default:
+		font->decoder = NULL;
+		break;
+	}
+
+	if (font->decoder) {
+		font->decoder->init(path, &font->glyph_count, &font->decoder_data);
+
+		if (font->glyph_count > 0) {
+			font->glyphs = (surface_t **) malloc(sizeof(surface_t *) * font->glyph_count);
+		} else {
+			font->glyphs = NULL;
+		}
+
+		if (font->glyphs) {
+			for (size_t i = 0; i < font->glyph_count; ++i) {
+				font->glyphs[i] = NULL;
+			}
+		} else {
+			font->glyph_count = 0;
+		}
+	} else {
+		font->glyph_count = 0;
+		font->glyphs = NULL;
+		font->decoder_data = NULL;
+	}
+}
+
+void font_release(font_t *font)
+{
+	if (font->glyphs) {
+		for (size_t i = 0; i < font->glyph_count; ++i) {
+			if (font->glyphs[i]) {
+				surface_destroy(font->glyphs[i]);
+			}
+		}
+		free(font->glyphs);
+	}
+	
+	if (font->decoder) {
+		font->decoder->release(font->decoder_data);
+	}
+}
+
+void font_get_box(font_t *font, char *text, sysarg_t *width, sysarg_t *height)
+{
+	assert(width);
+	assert(height);
+
+	(*width) = 0;
+	(*height) = 0;
+
+	if (!text) {
+		return;
+	}
+
+	while (*text) {
+		uint16_t glyph_idx = font->decoder->resolve(*text, font->decoder_data);
+		if (glyph_idx < font->glyph_count) {
+			if (!font->glyphs[glyph_idx]) {
+				font->glyphs[glyph_idx] =
+				    font->decoder->render(glyph_idx, font->points);
+			}
+
+			surface_t *glyph = font->glyphs[glyph_idx];
+			if (glyph) {
+				sysarg_t w;
+				sysarg_t h;
+				surface_get_resolution(glyph, &w, &h);
+				(*width) += w;
+				(*height) = (*height) < h ? h : (*height);
+			}
+		}
+		++text;
+	}
+}
+
+void font_draw_text(font_t *font, drawctx_t *context, source_t *source,
+    const char *text, sysarg_t x, sysarg_t y)
+{
+	assert(context);
+	assert(source);
+
+	drawctx_save(context);
+	drawctx_set_compose(context, compose_over);
+
+	while (*text) {
+		uint16_t glyph_idx = font->decoder->resolve(*text, font->decoder_data);
+		if (glyph_idx < font->glyph_count) {
+			if (!font->glyphs[glyph_idx]) {
+				font->glyphs[glyph_idx] =
+				    font->decoder->render(glyph_idx, font->points);
+			}
+
+			surface_t *glyph = font->glyphs[glyph_idx];
+			if (glyph) {
+				sysarg_t w;
+				sysarg_t h;
+				surface_get_resolution(glyph, &w, &h);
+
+				transform_t transform;
+				transform_identity(&transform);
+				transform_translate(&transform, x, y);
+				source_set_transform(source, transform);
+				source_set_mask(source, glyph, false);
+				drawctx_transfer(context, x, y, w, h);
+
+				x += w;
+			}
+		}
+		++text;
+	}
+
+	drawctx_restore(context);
+	source_set_mask(source, NULL, false);
+}
+
+/** @}
+ */
Index: uspace/lib/draw/font.h
===================================================================
--- uspace/lib/draw/font.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/font.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_FONT_H_
+#define DRAW_FONT_H_
+
+#include <sys/types.h>
+
+#include "surface.h"
+#include "source.h"
+
+struct drawctx;
+typedef struct drawctx drawctx_t;
+
+typedef enum {
+	FONT_DECODER_EMBEDDED
+} font_decoder_type_t;
+
+typedef struct {
+	void (*init)(char *, uint16_t *, void **);
+	uint16_t (*resolve)(const wchar_t, void *);
+	surface_t *(*render)(uint16_t, uint16_t);
+	void (*release)(void *);
+} font_decoder_t;
+
+typedef struct font {
+	uint16_t points;
+	uint16_t glyph_count;
+	surface_t **glyphs;
+	font_decoder_t *decoder;
+	void *decoder_data;
+} font_t;
+
+extern void font_init(font_t *, font_decoder_type_t, char *, uint16_t);
+extern void font_release(font_t *);
+
+extern void font_get_box(font_t *, char *, sysarg_t *, sysarg_t *);
+extern void font_draw_text(font_t *, drawctx_t *, source_t *, const char *,
+    sysarg_t, sysarg_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/font/embedded.c
===================================================================
--- uspace/lib/draw/font/embedded.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/font/embedded.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,118 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <sys/types.h>
+#include <malloc.h>
+
+#include "../gfx/font-8x16.h"
+#include "embedded.h"
+#include "../drawctx.h"
+
+static void fde_init(char *path, uint16_t *glyph_count, void **data)
+{
+	assert(glyph_count);
+	assert(data);
+
+	(*glyph_count) = FONT_GLYPHS;
+	(*data) = NULL;
+}
+
+static uint16_t fde_resolve(const wchar_t chr, void *data)
+{
+	return fb_font_glyph(chr);
+}
+
+static surface_t *fde_render(uint16_t glyph, uint16_t points)
+{
+	surface_t *template = surface_create(FONT_WIDTH, FONT_SCANLINES, NULL, 0);
+	if (!template) {
+		return NULL;
+	}
+	for (unsigned int y = 0; y < FONT_SCANLINES; ++y) {
+		for (unsigned int x = 0; x < FONT_WIDTH; ++x) {
+			pixel_t p = (fb_font[glyph][y] & (1 << (7 - x))) ? 
+			    PIXEL(255, 0, 0, 0) : PIXEL(0, 0, 0, 0);
+			surface_put_pixel(template, x, y, p);
+		}
+	}
+
+	source_t source;
+	source_init(&source);
+	source_set_texture(&source, template, false);
+
+	transform_t transform;
+	transform_identity(&transform);
+	if (points != FONT_SCANLINES) {
+		double ratio = ((double) points) / ((double) FONT_SCANLINES);
+		transform_scale(&transform, ratio, ratio);
+		source_set_transform(&source, transform);
+	}
+
+	double width = FONT_WIDTH;
+	double height = FONT_SCANLINES;
+	transform_apply_linear(&transform, &width, &height);
+	surface_t *result =
+	    surface_create((sysarg_t) (width + 0.5), (sysarg_t) (height + 0.5), NULL, 0);
+	if (!result) {
+		surface_destroy(template);
+		return NULL;
+	}
+
+	drawctx_t context;
+	drawctx_init(&context, result);
+	drawctx_set_source(&context, &source);
+	drawctx_transfer(&context, 0, 0,
+	    (sysarg_t) (width + 0.5), (sysarg_t) (height + 0.5));
+
+	surface_destroy(template);
+
+	return result;
+}
+
+static void fde_release(void *data)
+{
+	/* no-op */
+}
+
+font_decoder_t fd_embedded = {
+	.init = fde_init,
+	.resolve = fde_resolve,
+	.render = fde_render,
+	.release = fde_release
+};
+
+/** @}
+ */
